
#include <iostream>
#include <iomanip>
#include <iterator>

using namespace std;



struct datum{
    bool operator<(const datum &d);
    void kiir() const;

    int ev;
    int honap;
    int nap;
};

bool datum::operator<(const datum &d) {
    if (this->ev != d.ev)    return (this->ev < d.ev);
    if (this->honap != d.honap)    return (this->honap < d.honap);
    return (this->nap < d.nap);
}

istream& operator>>(istream& in, datum& d)
{
    in >> d.ev;
    in >> d.honap;
    in >> d.nap;
    return in;
}



template<typename T>
struct elem{
    static void beszur(elem<T>*& fa, T i, elem<T>* sulo);

    struct elem_iterator : public std::iterator<std::input_iterator_tag, T>
    {
        elem_iterator& operator++();
        bool operator!=(const elem_iterator& masik) const { return (aktualis!=masik.aktualis); }
        T operator*() const;

    private:
        friend class elem;
        elem_iterator(elem<T>* kezdeti) : aktualis(kezdeti) {}
        elem<T>* aktualis;
    };

    elem_iterator begin() const;
    elem_iterator end() const { return elem_iterator(0); }

// private:
    T d;
    elem<T>* jobb;
    elem<T>* bal;
    elem<T>* sz;
};

template<typename T>
typename elem<T>::elem_iterator& elem<T>::elem_iterator::operator++()
{
  // ez meg nincs megirva...
}

template<typename T>
typename elem<T>::elem_iterator elem<T>::begin() const
{
//    elem_iterator begin() const;
}

template<typename T>
void kiir(elem<T>* fa);

void datum::kiir() const
{
    cout << setw(4) << setfill('0') << ev << '.';
    cout << setw(2) << setfill('0') << honap << '.';
    cout << setw(2) << setfill('0') << nap;
    cout << endl;
}


template<typename T>
T beolvas() {
    T d;
    cin>> d.ev;
    cin>> d.honap;
    cin>> d.nap;
    return d;
}

int main()
{
    datum i;
    elem<datum>* fa=0;

    while(cin.good()){
//        i=beolvas();
        cin >> i;
        elem<datum>::beszur(fa,i,(elem<datum>*)0);
    }
//    kiir(fa);

    for (elem<datum>::elem_iterator it = fa->begin(); it != fa->end(); ++it)    (*it).kiir();

    return 0;
}

template<typename T>
void elem<T>::beszur(elem<T>*& fa, T i, elem<T>* sulo){
    if(fa!=0){
        if(i < fa->d){

            elem::beszur(fa->bal,i,fa);
        }
        else{

            elem::beszur(fa->jobb,i,fa);
        }
    }
    else{
        elem<T>* ujelem=new elem<T>;
        ujelem->d=i;
        ujelem->bal=ujelem->jobb=0;
        ujelem->sz=sulo;
        fa=ujelem;
    }
}


template<typename T>
void kiir(elem<T>* fa){
    if (fa)
    {
        kiir(fa->bal);

        kiir(fa->d);        // tul van terhelve!

        kiir(fa->jobb);
    }
}
