
#include <iostream>
#include <utility>
#include <list>
#include <iterator>
#include <algorithm>


using namespace std;


template <class T, class Q, class R>
class trio
{
public:
    trio(T k1,Q k2,R k3) : p(k1, pair<Q, R>(k2,k3) ) {  }
    T first() { return p.first; }
    Q second() { return p.second.first; }
    R third() { return p.second.second; }

    bool operator<(trio &j2) { return first() < j2.first(); }


private:
    pair<T,pair<Q,R> > p;
};


struct kereso
{
    bool operator()(trio<int,int,int> t)
    {
        return ( t.first() == 5 );
    }
};

struct atalakit
{
    trio<int,int,int> operator()(trio<int,int,int> t)
    {
        return trio<int,int,int>( t.first() + 1, t.second() + 1, t.third() + 1 );
    }
};

int main()
{
    //~ pair<int, float> p(1,1.1);
    //~ cout << p.first << ' ' << p.second << endl;
//~
    //~ trio<int, float, string>  t(1,1.1,"abc");
    //~ cout << t.first() << ' ' << t.second() << ' ' << t.third() << endl;


    //~ list<int>  il;
//~
    //~ il.push_front(3);
    //~ il.push_back(4);
//~
    //~ for (list<int>::iterator it = il.begin(); it != il.end(); ++it)
    //~ {
        //~ cout << *it << endl;
    //~ }
//~
    //~ for (list<int>::reverse_iterator it = il.rbegin(); it != il.rend(); ++it)
    //~ {
        //~ cout << *it << endl;
    //~ }

    const int vege = 8;

    list<trio<int,int,int> > lista;
    for(int i=1; i<=vege; ++i){
        lista.push_back(trio<int,int,int>(2 * i,i+1,i+2));
    }

    transform(lista.begin(), lista.end(), lista.begin(), atalakit());

    list<trio<int,int,int> > lista2;
    for(int i=1; i<=vege; ++i){
        lista2.push_back(trio<int,int,int>(2 * i - 1,i+1,i+2));
    }

    lista.merge(lista2);

    // find_if feltetel szerint keres
    for (list<trio<int,int,int> >::iterator it = find_if(lista.begin(),lista.end(),kereso()); it != lista.end(); ++it)
    {
//~ //        cout << (*it).first() << endl;
        cout << it->first() << " " << it->second() << " " << it->third() << endl;
    }


    //~ list<int> l;
//~
    //~ copy(istream_iterator<int>(cin), istream_iterator<int>(), back_inserter(l));
    //~ copy(l.begin(), l.end(), ostream_iterator<int>(cout, "\n"));

    return 0;
}
