
#include <iostream>
#include <list>
#include <iterator>
#include <algorithm>
#include "par.h"

using namespace std;

struct atalakit
{
    // ezzel fogjuk atalakitani lejjebb a sorozatot
    int operator()(int a)
    {
        return a + 1;
    }
};


int main()
{
    const int elemekSzama = 5;

    list<trio<int,int,int> > l,t;
    for(int i = 1; i < elemekSzama; ++i)
    {
        l.push_back(trio<int,int,int>(i,i+1,i+2));
    }

    cout << "list<trio<int,int,int> > ennyi elemet tartalmaz: " << l.size() << endl;

    for(list<trio<int,int,int> >::iterator a = l.begin();a != l.end(); ++a)
    {
        cout << (*a).first() << " "
             << (*a).second() << " "
             << a->third() << endl;
    }



    list<int> intlist, intlist2;
    intlist.push_back(1);
    intlist.push_back(6321);
    intlist.push_back(11473);
    intlist.push_back(11436);

    // igy egybeomlesztve irja ki a szamokat
    copy(intlist.begin(), intlist.end(), ostream_iterator<int>(cout));

    cout << endl << endl;

    cout << "igy egy sortores is kerul minden kiirt ertek koze" << endl;
    copy(intlist.begin(), intlist.end(), ostream_iterator<int>(cout, "\n"));

    cout << endl;

    cout << "atalakitjuk az intlist-et az atalakit::operator()(int) segitsegevel" << endl;
    transform(intlist.begin(), intlist.end(), intlist.begin(), atalakit());
    copy(intlist.begin(), intlist.end(), ostream_iterator<int>(cout, "\n"));

    return 0;
}
