
#include <iostream>
#include <iomanip>

using namespace std;



struct datum{
    bool operator<(const datum &d);

    int ev;
    int honap;
    int nap;
};

bool datum::operator<(const datum &d) {
    if (this->ev != d.ev)    return (this->ev < d.ev);
    if (this->honap != d.honap)    return (this->honap < d.honap);
    return (this->nap < d.nap);
}


istream& operator>>(istream& in, datum& d)
{
    in >> d.ev;
    in >> d.honap;
    in >> d.nap;
    return in;
}


struct elem{
    datum d;
    elem* jobb;
    elem* bal;
};

void beszur(elem*& fa, datum i);

void kiir(elem* fa);

void kiir(datum e)
{
    cout << setw(4) << setfill('0') << e.ev << '.';
    cout << setw(2) << setfill('0') << e.honap << '.';
    cout << setw(2) << setfill('0') << e.nap;
    cout << endl;
}


void torol(elem*& e)
{
    if (e->jobb)    torol(e->jobb);
    if (e->bal)    torol(e->bal);
    delete e;
    e = 0;
}


datum beolvas() {
    datum d;
    cin>> d.ev;
    cin>> d.honap;
    cin>> d.nap;
    return d;
}


int main()
{
    datum i;
    elem* fa=0;

    while(cin.good()){
//        i=beolvas();
        cin >> i;
        beszur(fa,i);
    }
    kiir(fa);

    torol(fa);

    cout << "torles utan..." << endl;

    kiir(fa);

    return 0;
}

void beszur(elem*& fa, datum i){
    if(fa!=0){
        if(i < fa->d){
            beszur(fa->bal,i);
        }
        else{
            beszur(fa->jobb,i);
        }
    }
    else{
        elem* ujelem=new elem;
        ujelem->d=i;
        ujelem->bal=ujelem->jobb=0;
        fa=ujelem;
    }
}



void kiir(elem* fa){
    if (fa)
    {
        kiir(fa->bal);

        kiir(fa->d);        // tul van terhelve!

        kiir(fa->jobb);
    }
}
